package com.iot.puc.aplication;

import android.app.ActionBar;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.ClipData;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Point;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.media.AudioManager;
import android.media.Image;
import android.media.MediaPlayer;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Editable;
import android.text.InputFilter;
import android.text.InputType;

import android.text.TextWatcher;

import android.util.Log;
import android.view.DragEvent;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;

import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;

import android.widget.ListView;
import android.widget.RelativeLayout;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Set;
import java.util.UUID;


public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    private Handler mHandler = new Handler();
    //Bluetooh
    BluetoothAdapter mBluetoothAdapter;
    BluetoothSocket mmSocket;
    BluetoothDevice mmDevice;
    OutputStream mmOutputStream;
    InputStream mmInputStream;
    Thread workerThread;
    volatile boolean stopWorker;
    int readBufferPosition;
    byte[] readBuffer;

    int contador;
    ArrayAdapter<ItemMazeMap> adapter;
    List<ItemMazeMap> listMazeMaps = new ArrayList<ItemMazeMap>();

    int currenttrack = 0;
    int[] tracks = new int[5];

    CustomKeyboard mCustomKeyboard;

    ImageButton  btn_start, btn_end, btn_up, btn_right,btn_left, btn_down,btn_ligh,btn_hand,btn_arrow, btn_and, btn_or,btn_if ;
    ImageButton btn_ligh_logic,btn_hand_logic,btn_arrow_logic;
    RelativeLayout LyProgram;


    ImageButton btn_start_arduinocar;
    LinearLayout  LyButtons, LyAnswer, LyAnswer01, LyLogicButtons, LyAnswer03, LyAnswer04;
    RelativeLayout LyAnswerAll;
    private static final float SIZE_IMAGEBUTTON = 80.0f;
    private int heightLayout = 0;
    // Answer Buttons
    ImageButton button_answ_start,btn_end_answer,btn_up_answer2,btn_answ_arrow,btn_up_answer1;
    ImageButton btn_light_answer,btn_right_answer3,btn_right_answer2,btn_right_answer1,btn_hand_answer;

    // Answer  Buttons task 2

    ImageButton btn_answer1_and, btn_answer1_right1, btn_answer1_right2, btn_answer1_right3, btn_answer1_or;
    ImageButton btn_answer1_up, btn_answer1_end, btn_answer1_up1, btn_answer1_start;

    ListView lvTask;

    ArrayList<stateAnswerButtons> listAnswerButtons  = new ArrayList<stateAnswerButtons>();

    private MediaPlayer mediaPlayer;
    boolean isOpeningBt = false;

    private String aceleration, direction;

    Animation animScale=null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        contador=0;
        aceleration="stop";
        direction="up";
        clearTraksList();
        setContentView(R.layout.activity_main);

        animScale = AnimationUtils.loadAnimation(this,R.anim.animation_scale);

        fillListTask();
        lvTask = (ListView)findViewById(R.id.lvTask);
        adapter = new MyAdapterMazeMapsList(this, listMazeMaps);
        lvTask.setAdapter(adapter);
        lvTask.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                changeViewListView(position);
            }
        });
        // Button to progrmam
        btn_start = (ImageButton)findViewById(R.id.btn_start);
        btn_end = (ImageButton)findViewById(R.id.btn_end);
        btn_up = (ImageButton)findViewById(R.id.btn_up);
        btn_right = (ImageButton)findViewById(R.id.btn_right);
        btn_left = (ImageButton)findViewById(R.id.btn_left);
        btn_down = (ImageButton)findViewById(R.id.btn_down);
        btn_ligh = (ImageButton)findViewById(R.id.btn_ligh);
        btn_hand = (ImageButton)findViewById(R.id.btn_hand);
        btn_arrow = (ImageButton)findViewById(R.id.btn_arrow);
        btn_and = (ImageButton)findViewById(R.id.btn_and);
        btn_or = (ImageButton)findViewById(R.id.btn_or);
        btn_if = (ImageButton)findViewById(R.id.btn_if);


        // Layouts
        LyProgram = (RelativeLayout)findViewById(R.id.LyProgram);
        LyButtons = (LinearLayout)findViewById(R.id.LyButtons);
        LyAnswer = (LinearLayout)findViewById(R.id.LyAnswer);
        LyAnswer01 = (LinearLayout)findViewById(R.id.LyAnswer01);
        LyAnswer03=  (LinearLayout)findViewById(R.id.LyAnswer03);
        LyAnswer04=  (LinearLayout)findViewById(R.id.LyAnswer04);
        LyLogicButtons = (LinearLayout)findViewById(R.id.LyLogicButtons);

        LyAnswerAll =(RelativeLayout)findViewById(R.id.LyAnswerAll);

        LyAnswer01.setVisibility(View.INVISIBLE);
        LyAnswer.setVisibility(View.INVISIBLE);
        LyAnswer03.setVisibility(View.INVISIBLE);
        LyAnswer04.setVisibility(View.INVISIBLE);


        // Button to answer
        button_answ_start = (ImageButton)findViewById(R.id.button_answ_start);
        btn_end_answer = (ImageButton)findViewById(R.id.btn_end_answer);
        btn_up_answer2 = (ImageButton)findViewById(R.id.btn_up_answer2);
        btn_answ_arrow = (ImageButton)findViewById(R.id.btn_answ_arrow);
        btn_up_answer1 = (ImageButton)findViewById(R.id.btn_up_answer1);
        btn_light_answer = (ImageButton)findViewById(R.id.btn_light_answer);
        btn_right_answer3 = (ImageButton)findViewById(R.id.btn_right_answer3);
        btn_right_answer2 = (ImageButton)findViewById(R.id.btn_right_answer2);
        btn_right_answer1 = (ImageButton)findViewById(R.id.btn_right_answer1);
        btn_hand_answer = (ImageButton)findViewById(R.id.btn_hand_answer);

        // Button to answer task 2
        btn_answer1_and = (ImageButton)findViewById(R.id.btn_answer1_and);
        btn_answer1_right1 = (ImageButton)findViewById(R.id.btn_answer1_right1);
        btn_answer1_right2 = (ImageButton)findViewById(R.id.btn_answer1_right2);
        btn_answer1_right3 = (ImageButton)findViewById(R.id.btn_answer1_right3);
        btn_answer1_or = (ImageButton)findViewById(R.id.btn_answer1_or);
        btn_answer1_up = (ImageButton)findViewById(R.id.btn_answer1_up);
        btn_answer1_end = (ImageButton)findViewById(R.id.btn_answer1_end);
        btn_answer1_up1 = (ImageButton)findViewById(R.id.btn_answer1_up1);
        btn_answer1_start = (ImageButton)findViewById(R.id.btn_answer1_start);



        btn_ligh_logic  = (ImageButton)findViewById(R.id.btn_ligh_logic);
        btn_hand_logic  = (ImageButton)findViewById(R.id.btn_hand_logic);
        btn_arrow_logic  = (ImageButton)findViewById(R.id.btn_arrow_logic);


        btn_ligh_logic.setOnClickListener(this);
        btn_hand_logic.setOnClickListener(this);
        btn_arrow_logic.setOnClickListener(this);

        // Buton  to start car with arduino

        btn_start_arduinocar = (ImageButton)findViewById(R.id.btn_start_arduinocar);
        btn_start_arduinocar.setEnabled(false);
        btn_start_arduinocar.setOnClickListener(this);

   


        btn_start.setTag(new tagImagens("start"));
        btn_end.setTag(new tagImagens("end"));
        btn_up.setTag(new tagImagens("up"));
        btn_down.setTag(new tagImagens("down"));
        btn_right.setTag(new tagImagens("right"));
        btn_left.setTag(new tagImagens("left"));
        btn_ligh.setTag(new tagImagens("light"));
        btn_hand.setTag(new tagImagens("hand"));
        btn_arrow.setTag(new tagImagens("arrow"));
        btn_and.setTag(new tagImagens("and"));
        btn_or.setTag(new tagImagens("or"));
        btn_if.setTag(new tagImagens("if"));


        LyProgram.setTag(new tagImagens("layProgram"));




        btn_start.setOnTouchListener(new MiTouchListener());
        btn_end.setOnTouchListener(new MiTouchListener());
        btn_up.setOnTouchListener(new MiTouchListener());
        btn_down.setOnTouchListener(new MiTouchListener());
        btn_right.setOnTouchListener(new MiTouchListener());
        btn_left.setOnTouchListener(new MiTouchListener());
        btn_ligh.setOnTouchListener(new MiTouchListener());
        btn_hand.setOnTouchListener(new MiTouchListener());
        btn_arrow.setOnTouchListener(new MiTouchListener());
        btn_and.setOnTouchListener(new MiTouchListener());
        btn_or.setOnTouchListener(new MiTouchListener());
        btn_if.setOnTouchListener(new MiTouchListener());


        LyProgram.setOnDragListener(new MiDragListener());

        //createTask1();
    }


    public void addListAnsw1()
    {
        listAnswerButtons.clear();

        listAnswerButtons.add(new stateAnswerButtons(button_answ_start,"start",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_up_answer2,"up",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_up_answer1,"up",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_hand_answer,"hand",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_right_answer1,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_right_answer2,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_right_answer3,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_light_answer, "light", false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answ_arrow, "arrow", false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_end_answer, "end", false,0));

        // disable all buttons
        for(int i = 0; i<listAnswerButtons.size();i++) {
            ImageButton imageButton = listAnswerButtons.get(i).getButton_name();
            imageButton.setEnabled(listAnswerButtons.get(i).isState());
        }


    }
    private void  addListAnsw2()
    {
        listAnswerButtons.clear();
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_start, "start", false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_up1,"up",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_up, "up", false, 0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_and,"and",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_and,"arrow",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_and,"light",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_right1,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_right2,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_right3,"right",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_or,"or",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_or,"arrow",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_or,"hand",false,0));
        listAnswerButtons.add(new stateAnswerButtons(btn_answer1_end,"end",false,0));

        // disable all buttons
        for(int i = 0; i<listAnswerButtons.size();i++) {
            ImageButton imageButton = listAnswerButtons.get(i).getButton_name();
            imageButton.setEnabled(listAnswerButtons.get(i).isState());
        }

    }

    private void clearLyProgram()
    {

        if(LyProgram.getChildCount()>0)
          LyProgram.removeAllViews();
    }
    public void changeViewListView(int position)
    {
        for (int i = 0; i<listMazeMaps.size(); i++)
        {
            listMazeMaps.get(i).setSelected(false);
        }

        listMazeMaps.get(position).setSelected(true);
        adapter.notifyDataSetChanged();

        btn_start_arduinocar.setEnabled(false);
        clearLyProgram();

        LyProgram.setBackground(getResources().getDrawable(R.drawable.lay_background01));
        LyLogicButtons.setBackground(getResources().getDrawable(R.drawable.lay_backgroud));
        LyAnswerAll.setBackground(getResources().getDrawable(R.drawable.lay_backgroud));

        switch (position){
            case 0:
                LyAnswer.setVisibility(View.VISIBLE);
                LyAnswer01.setVisibility(View.INVISIBLE);
                LyAnswer03.setVisibility(View.INVISIBLE);
                LyAnswer04.setVisibility(View.INVISIBLE);
                addListAnsw1();
                break;
            case 1:
                LyAnswer.setVisibility(View.INVISIBLE);
                LyAnswer01.setVisibility(View.VISIBLE);
                LyAnswer03.setVisibility(View.INVISIBLE);
                LyAnswer04.setVisibility(View.INVISIBLE);
                addListAnsw2();
                break;
            case 2:
                LyAnswer03.setVisibility(View.VISIBLE);
                LyAnswer.setVisibility(View.INVISIBLE);
                LyAnswer01.setVisibility(View.INVISIBLE);
                LyAnswer04.setVisibility(View.INVISIBLE);
                break;
            case 3:
                LyAnswer03.setVisibility(View.INVISIBLE);
                LyAnswer.setVisibility(View.INVISIBLE);
                LyAnswer01.setVisibility(View.INVISIBLE);
                LyAnswer04.setVisibility(View.VISIBLE);
                break;
            default:
                LyAnswer.setVisibility(View.INVISIBLE);
                LyAnswer01.setVisibility(View.INVISIBLE);
                LyAnswer03.setVisibility(View.INVISIBLE);
                LyAnswer04.setVisibility(View.INVISIBLE);
        }

    }

    private void fillListTask() {

        Drawable dr = getResources().getDrawable(R.drawable.task1);
        Drawable dr2 = getResources().getDrawable(R.drawable.task2);
        Drawable dr3 = getResources().getDrawable(R.drawable.task3);
        Drawable dr4 = getResources().getDrawable(R.drawable.task4);

        Bitmap bitmap = ((BitmapDrawable) dr).getBitmap();
        Bitmap bitmap2 = ((BitmapDrawable) dr2).getBitmap();
        Bitmap bitmap3 = ((BitmapDrawable) dr3).getBitmap();
        Bitmap bitmap4 = ((BitmapDrawable) dr4).getBitmap();



        listMazeMaps.add(new ItemMazeMap("task1",bitmap, false));
        listMazeMaps.add(new ItemMazeMap("task2",bitmap2, false));
        listMazeMaps.add(new ItemMazeMap("task3",bitmap3, false));
        listMazeMaps.add(new ItemMazeMap("task4", bitmap4, false));

    }

    private void clearTraksList() {
        System.out.println("clearTraksList");
        for(int i = 0; i<tracks.length; i++)
            tracks[i] =0;

    }

    @Override
    protected void onStart() {
        super.onStart();



        LyProgram.post(new Runnable() {
            int withtLayout = 0;

            @Override
            public void run() {
                Log.i("TEST", "Layout width : " + LyProgram.getWidth());
                withtLayout = LyProgram.getWidth();
                heightLayout = LyProgram.getHeight();
                System.out.println("Hight Layout : "+heightLayout);
               
            }
        });

        // open bluetooh conection

        findBluetooh();

    }

   
    private void  findBluetooh()
    {

        try
        {
            findBT();
            openBT();
            isOpeningBt = true;
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    private void sendDataToArduino() throws IOException {

        if(isOpeningBt) {

         // all coming in start

            for ( int i = 0; i < listAnswerButtons.size(); i++) {

                stateAnswerButtons stateAnswer = listAnswerButtons.get(i);
                if (stateAnswer.isState()) {
                    String sentence = listAnswerButtons.get(i).getSentence_name();
                    SendDataRequest sendDataRequest = new SendDataRequest(this);
                    final int finalI = i;
                    sendDataRequest.TimeoutOperation(stateAnswer, new GetDataArduino() {
                        @Override
                        public void done(String result) throws IOException {
                            doSendToArduino(finalI);
                        }
                    });
                    if (i < listAnswerButtons.size() - 1)// is for not storage
                    {
                        String nextSentence = listAnswerButtons.get(i + 1).getSentence_name();
                        boolean nextState = listAnswerButtons.get(i+1).isState();

                        if ((nextSentence.equals("hand") || nextSentence.equals("arrow") || nextSentence.equals("light") || nextSentence.equals("or")||nextSentence.equals("and"))&&nextState)
                        {
                            contador = i + 1;
                            break;
                        }
                    }


                }

            }
        }
    }
    private void doSendToArduino(int position ) throws IOException {

        String sentence = listAnswerButtons.get(position).getSentence_name();
        sendData(sentence);

        // song
        try {

            tracks[0] = R.raw.light;
            playSongFile(tracks);


        } catch (IOException e) {
            e.printStackTrace();
        }


        if(position<(listAnswerButtons.size()-1))
        {

            String nextSentence = listAnswerButtons.get(position + 1).getSentence_name();
            boolean nextState = listAnswerButtons.get(position+1).isState();

            if ((nextSentence.equals("hand") || nextSentence.equals("arrow") || nextSentence.equals("light")|| nextSentence.equals("or")||nextSentence.equals("and"))&&nextState)
            {
                String namesent= "end";
                sendData(namesent);

            }

        }

        }


    private void doStuff(int contador) {
        ImageButton imageButton = listAnswerButtons.get(contador).getButton_name();
        imageButton.setEnabled(false);

    }

    private void changeStateButton(int i) {
        System.out.println("retorno:"+i);
       ImageButton imageButton = listAnswerButtons.get(i).getButton_name();
        imageButton.setEnabled(true);

    }

    private void doSendData() {

        System.out.println("volvio..");
           if(contador< listAnswerButtons.size())
            {
                System.out.println("contador:"+ contador);
                stateAnswerButtons stateAnswer = listAnswerButtons.get(contador);

                if(stateAnswer.isState() )// verify if the button not is enabled
                {
                    String nameButton =  stateAnswer.getSentence_name();
                    System.out.println("nameButton:"+ nameButton );
                    ImageButton imageButton = listAnswerButtons.get(contador).getButton_name();
                 
                    listAnswerButtons.get(contador).setState(false);
                    imageButton.setEnabled(listAnswerButtons.get(contador).isState());
                    contador++;
                    System.out.println("contador nuevo:"+ contador);

            }
        }


    }


    @Override
    public void onBackPressed() {
        // NOTE Trap the back key: when the CustomKeyboard is still visible hide it, only when it is invisible, finish activity
        if( mCustomKeyboard.isCustomKeyboardVisible() ) mCustomKeyboard.hideCustomKeyboard(); else this.finish();
    }

    @Override
    public void onClick(View v) {

        switch (v.getId())
        {
            case R.id.btn_ligh_logic:

                    validateClickButton("light", btn_ligh_logic);
                 break;
            case R.id.btn_hand_logic:

                 validateClickButton("hand",btn_hand_logic );
                break;
            case R.id.btn_arrow_logic:
                    validateClickButton("arrow",btn_arrow_logic );
                break;
            case  R.id.btn_start_arduinocar:

                // send data to Arduino
                try {
                    sendDataToArduino();
                } catch (IOException e) {
                    e.printStackTrace();
                }

                break;

        }
    }
    private void validateClickButton(String nameButton, ImageButton imageButton)  {
        String sentence_name  = listAnswerButtons.get(contador).getSentence_name();

        System.out.println("contador:"+contador);

        if(sentence_name.equals("and"))
        {
            String nextsentence1 = listAnswerButtons.get(contador+1).getSentence_name();
            String nextsentence2 = listAnswerButtons.get(contador+2).getSentence_name();
            if(nextsentence1.equals(nameButton)) {
                listAnswerButtons.get(contador + 1).setState(false);
                imageButton.setEnabled(false);
                System.out.println(" siguiente boton del and");
                try {

                    tracks[0] = R.raw.light;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            else if(nextsentence2.equals(nameButton)) {
                listAnswerButtons.get(contador + 2).setState(false);
                imageButton.setEnabled(false);
                System.out.println(" mas siguiente boton del and");
                try {

                    tracks[0] = R.raw.light;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            else{
                try {

                    tracks[0] = R.raw.error;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            if(!listAnswerButtons.get(contador+1).isState()&&!listAnswerButtons.get(contador+2).isState())
            {
                enableLogicsButton();
                try {
                    sendDataToArduino();
                } catch (IOException e) {
                    e.printStackTrace();
                }

            }

            for(int i = 0; i<listAnswerButtons.size(); i++)
            {
                System.out.println("states of buttons");
                System.out.print(listAnswerButtons.get(i).getSentence_name() + " "+ listAnswerButtons.get(i).isState() );

            }

        }
        else if (sentence_name.equals("or"))
        {
            String nextsentence1 = listAnswerButtons.get(contador+1).getSentence_name();
            String nextsentence2 = listAnswerButtons.get(contador+2).getSentence_name();
            if(nextsentence1.equals(nameButton)) {
                listAnswerButtons.get(contador + 1).setState(false);
                imageButton.setEnabled(false);
                try {

                    tracks[0] = R.raw.light;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            else if(nextsentence2.equals(nameButton)) {
                listAnswerButtons.get(contador + 2).setState(false);
                imageButton.setEnabled(false);
                try {

                    tracks[0] = R.raw.light;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            else{
                try {

                    tracks[0] = R.raw.error;
                    playSongFile(tracks);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            if(!listAnswerButtons.get(contador+1).isState()||!listAnswerButtons.get(contador+2).isState())
            {
                listAnswerButtons.get(contador + 1).setState(false);
                listAnswerButtons.get(contador + 2).setState(false);

                enableLogicsButton();
                try {
                    sendDataToArduino();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }



            for(int i = 0; i<listAnswerButtons.size(); i++)
            {
                System.out.println("states of buttons");
                System.out.print(listAnswerButtons.get(i).getSentence_name() + " "+ listAnswerButtons.get(i).isState() );

            }
        }
        else if(sentence_name.equals(nameButton)) {
            try {
                sendDataToArduino();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        else
        {
            try {

                tracks[0] = R.raw.error;
                playSongFile(tracks);

            } catch (IOException e) {
                e.printStackTrace();
            }

        }

    }
    private void enableLogicsButton()
    {
        btn_ligh_logic.setEnabled(true);
        btn_hand_logic.setEnabled(true);
        btn_arrow_logic.setEnabled(true);
    }
    private class MiTouchListener implements View.OnTouchListener {
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {

            if(motionEvent.getAction()==MotionEvent.ACTION_DOWN) {
                ClipData data = ClipData.newPlainText("", "");
                View.DragShadowBuilder shadowBuilder = new
                        View.DragShadowBuilder(view);

                view.startDrag(data, shadowBuilder, view, 0);
                return true;
            }
            else{
                return false;
            }
        }
    }
    private class MiDragListener implements View.OnDragListener {

       // Drawable enterShape = getResources().getDrawable(R.drawable.shape_droptarget);

        @Override
        public boolean onDrag(View v, DragEvent event) {

            int accion = event.getAction();
            View view = (View)event.getLocalState();
            String  nametag = ((tagImagens)v.getTag()).getNameimg();
            Point touchPosition = new Point();
            switch (accion)
            {
                case DragEvent.ACTION_DRAG_STARTED:
                    break;
                case DragEvent.ACTION_DRAG_ENTERED:
                    //v.setBackground(enterShape);
                    String nameTag  =  ((tagImagens)v.getTag()).getNameimg();
                    if(nameTag.equals("shadow")|| nameTag.equals("shadow_logic")) {
                        v.setBackgroundColor(getResources().getColor(R.color.colorGreen));
                    }
                    break;
                case DragEvent.ACTION_DRAG_EXITED:
                    String nameTagEx  =  ((tagImagens)v.getTag()).getNameimg();
                    if(nameTagEx.equals("shadow")) {
                        v.setBackgroundColor(getResources().getColor(R.color.colorAccent));
                    }
                   // v.setBackground(null);
                    break;
                case DragEvent.ACTION_DRAG_LOCATION:
                    touchPosition = getTouchPositionFromDragEvent(v, event);

                    break;
                case DragEvent.ACTION_DROP:
                    // aqui se  tiene que encender la luz en el otro
                    // lado y tambien dar un sonido de bueno o malo

                    View dragedImage = (View) event.getLocalState();
                    String dragedImageName = ((tagImagens)dragedImage.getTag()).getNameimg();

                    String nameDragedIn = ((tagImagens)v.getTag()).getNameimg();

                    if(verifyNextButton(dragedImageName)) { // verify if is correct image droped

                        // is equal to one because is considerate thhe button start car
                        if (LyProgram.getChildCount() == 0 && v == findViewById(R.id.LyProgram)) {
                            //Drawable drawable = getResources().getDrawable(R.drawable.start);

                            ViewGroup dragedImageViewParentLayout = (ViewGroup) dragedImage.getParent();

                            dragedImageViewParentLayout.removeView(dragedImage);

                            RelativeLayout containView = (RelativeLayout) v;

                            RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);

                            float X = event.getX();
                            float Y = event.getY();
                            Point point = new Point(Math.round(X), Math.round(Y));

                            params.leftMargin = Math.round(X);
                            params.topMargin = Math.round(Y);

                            dragedImage.setLayoutParams(params);
                            containView.addView(dragedImage);
                            view.setVisibility(View.VISIBLE);

                            try {

                                tracks[0] = R.raw.light;
                                playSongFile(tracks);

                            } catch (IOException e) {
                                e.printStackTrace();
                            }

                            // add new buttom
                            int index = LyButtons.indexOfChild(dragedImage);
                            System.out.println("Index:" + Integer.toString(index));
                            createNewButtonImage(dragedImageName, index);
                            desingNextButtom(point);

                            try {
                                verifyAnswerLayout(dragedImageName);
                            } catch (IOException e) {
                                e.printStackTrace();
                            }

                        } else if (LyProgram.getChildCount() > 0 && (nameDragedIn.equals("shadow")|| nameDragedIn.equals("shadow_logic"))) {
                            ViewGroup dragedImageViweParentLayout = (ViewGroup) dragedImage.getParent();
                            dragedImageViweParentLayout.removeView(dragedImage);
                            //LinearLayout containView = (LinearLayout) v;

                            RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);

                            Point positionShadow = removeShadow(nameDragedIn);

                            params.leftMargin = positionShadow.x;// because is created closed image
                            params.topMargin = positionShadow.y;

                            dragedImage.setLayoutParams(params);
                            System.out.println("Drop image : ");
                            System.out.println("leftMargin : " + params.leftMargin);
                            System.out.println("topMargin : " + params.topMargin);
                            LyProgram.addView(dragedImage);
                            view.setVisibility(View.VISIBLE);

                            /**create a editText for image only the row
                             * */

                            designTextArrow(positionShadow, dragedImageName);


                            try {

                                tracks[0] = R.raw.light;
                                playSongFile(tracks);

                            } catch (IOException e) {
                                e.printStackTrace();
                            }


                            if (dragedImageName.equals("or") || dragedImageName.equals("and")) {
                                designShadows(positionShadow);
                                desingNextButtom(positionShadow);
                            } else if (dragedImageName.equals("if")) {
                                designShadows(positionShadow);
                            } else if (!dragedImageName.equals("end") && !nameDragedIn.equals("shadow_logic")) {
                                desingNextButtom(positionShadow);
                            }


                            int index = LyButtons.indexOfChild(dragedImage);
                            System.out.println("Index:" + Integer.toString(index));
                            createNewButtonImage(dragedImageName, index);
                            try {
                                verifyAnswerLayout(dragedImageName);
                            } catch (IOException e) {
                                e.printStackTrace();
                            }

                        }
                    }
                    else
                    {  //song  erro
                        try {

                            tracks[0] = R.raw.error;
                            playSongFile(tracks);

                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                    }


                case DragEvent.ACTION_DRAG_ENDED:
                  //  v.setBackground(null);
                    String nameTagEnded =  ((tagImagens)v.getTag()).getNameimg();
                    if( nameTagEnded.equals("shadow")) {
                        v.setBackgroundColor(getResources().getColor(R.color.colorGray));
                    }

                    break;
                default:
                    break;
            }
            return true;
        }
    }

    private void designTextArrow(Point positionShadow, String dragedImageName) {


        if(dragedImageName.equals("up") ||dragedImageName.equals("down")||dragedImageName.equals("right")|| dragedImageName.equals("left") )
        {

            System.out.println("en EditText");
            EditText myEditText = new EditText(this); // Pass it an Activity or Context
            myEditText.setText("1");

            RelativeLayout.LayoutParams paramsText = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);


            paramsText.leftMargin = positionShadow.x + 40;
            paramsText.topMargin = positionShadow.y + 150;

            System.out.print( "paramsText.leftMargin: "+paramsText.leftMargin );
            System.out.print( "paramsText.topMargin: "+paramsText.topMargin );
            paramsText.width = 60;

            myEditText.setLayoutParams(paramsText); // Pass two args; must be LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT, or an integer pixel value.
            myEditText.setBackgroundColor(getResources().getColor(R.color.colorWhite));

            // tag
            myEditText.setTag(new tagImagens(dragedImageName));
            // number of digits in Editext

            int maxLength = 1;
            InputFilter[] fArray = new InputFilter[1];
            fArray[0] = new InputFilter.LengthFilter(maxLength);
            myEditText.setFilters(fArray);

            // bacground
            myEditText.setBackground(getResources().getDrawable(R.drawable.edittext_bg));
            //center text inside of editText
            myEditText.setGravity(Gravity.CENTER_HORIZONTAL);

            // add textchanged


            myEditText.setInputType(InputType.TYPE_CLASS_NUMBER);
            myEditText.addTextChangedListener(mTextEditorWatcher);
            LyProgram.addView(myEditText);
            myEditText.setVisibility(View.VISIBLE);
        }


    }
    private Activity activity;
    private final TextWatcher mTextEditorWatcher = new TextWatcher() {
        @Override
        public void beforeTextChanged(CharSequence s, int start, int count, int after) {

        }

        @Override
        public void onTextChanged(CharSequence s, int start, int before, int count) {

        }

        @Override
        public void afterTextChanged(Editable editable) {
            //verify the numbers change for feedback

            if(editable.toString()=="") return;
            int childcount = LyProgram.getChildCount();
            for (int i=0; i < childcount; i++) {
                View child = LyProgram.getChildAt(i);
                if(child!=null && child.getClass()==EditText.class)
                {
                   EditText editText = (EditText)child;

                    if(editable==editText.getEditableText())
                    {
                        String texto = editable.toString();
                        tagImagens editTag = (tagImagens) editText.getTag();
                        verifyAnswerArrow(editTag, texto, editText);


                        break;
                    }
                }
            }

       

        }
    };

    private void verifyAnswerArrow(tagImagens editTag, String texto, EditText editText ) {

        if(texto.equals("")) return;

        ArrayList<stateAnswerButtons> list  = new ArrayList<stateAnswerButtons>();
        int count =1;

        for (int i = 0; i<listAnswerButtons.size(); i++)
        {
            stateAnswerButtons stateAnswer = listAnswerButtons.get(i);

            if(!stateAnswer.isState() )// verify if the button not is enabled
            {
                String nameButton =  stateAnswer.getSentence_name();
                if(nameButton.equals(editTag.getNameimg()))
                {
                    list.add(stateAnswer);
                    System.out.println("Um mais na lista");
                }
                else {
                    break; // para el for porque no precisa seguir buscando mas
                }
            }
        }

        int total  = count + list.size();

        System.out.println("total:"+total);
        System.out.println("list.size:" + list.size());

        if(Integer.parseInt(texto)==total && list.size()>0)
        {
            for(int i = 0 ; i<list.size(); i++) {
                stateAnswerButtons stateAnsw = list.get(i);
                ImageButton  imageButton = stateAnsw.getButton_name();

                for (int r = 0;r<listAnswerButtons.size(); r++)
                {
                  ImageButton imageButtonLisAnsw =   listAnswerButtons.get(r).getButton_name();
                    if(imageButton.getId() ==imageButtonLisAnsw.getId())
                    {
                        imageButtonLisAnsw.setEnabled(true);
                        listAnswerButtons.get(r).setState(true);


                        // Force EditText to remove focus

                    }
                }
           
                try {

                    for (int j=0; j<(total-1); j++)// comienza en uno porque ya se encendio una luz
                    {
                        tracks[j] = R.raw.light;
                    }

                    playSongFile(tracks);


                } catch (IOException e) {
                    e.printStackTrace();
                }
                editText.setEnabled(false);
            }

        }
        else
        {
            //song  erro
            try {

                tracks[0] = R.raw.error;
                playSongFile(tracks);

            } catch (IOException e) {
                e.printStackTrace();
            }
        }


    }


    private void verifyAnswerLayout(String dragedImagename) throws IOException {
        boolean isEndButton = false;

        for (int i = 0; i < listAnswerButtons.size(); i++) {

            stateAnswerButtons stateAnswer = listAnswerButtons.get(i);

            if (!stateAnswer.isState())// verify if the button not is enabled
            {
                String nameButton = stateAnswer.getSentence_name();
                if(nameButton.equals("and") ||  nameButton.equals("or")) {
                    String nextName = listAnswerButtons.get(i + 1).getSentence_name();
                    String nextName2 = listAnswerButtons.get(i + 2).getSentence_name();
                    if(nameButton.equals(dragedImagename))
                    {

                        listAnswerButtons.get(i).setLyprogram(1);
                    }
                    else if(nextName.equals(dragedImagename))
                    {
                        listAnswerButtons.get(i+1).setLyprogram(1);
                    }
                    else if(nextName2.equals(dragedImagename))
                    {
                        listAnswerButtons.get(i+2).setLyprogram(1);
                    }

                    if(listAnswerButtons.get(i).getLyprogram()==1&& listAnswerButtons.get(i+1).getLyprogram()==1&& listAnswerButtons.get(i+2).getLyprogram()==1)
                    {
                        ImageButton imageButton = stateAnswer.getButton_name();
                        imageButton.setEnabled(true);
                        listAnswerButtons.get(i).setState(true);
                        listAnswerButtons.get(i+1).setState(true);
                        listAnswerButtons.get(i+2).setState(true);
                    }

                }
                if (nameButton.equals(dragedImagename)) {
                    ImageButton imageButton = stateAnswer.getButton_name();
                    imageButton.setEnabled(true);
                    listAnswerButtons.get(i).setState(true);
                    listAnswerButtons.get(i).setLyprogram(1);

                    if (nameButton.equals("end")) isEndButton = true;
                }
                break; // para el for porque no precisa seguir buscando mas
            }
        }

        if (isEndButton) {


            enableButtonCarArduino();

        }


    }

    private void enableButtonCarArduino() throws IOException {
       

        btn_start_arduinocar.setEnabled(true);
        btn_start_arduinocar.startAnimation(animScale);
        tracks[0] = R.raw.aplausos;
        tracks[1] = R.raw.claxon_carro;
        tracks[2] = R.raw.motor_two;
        playSongFile(tracks);

        LyLogicButtons.setBackground(getResources().getDrawable(R.drawable.lay_background01));
        LyAnswerAll.setBackground(getResources().getDrawable(R.drawable.lay_background01));
        LyProgram.setBackground(getResources().getDrawable(R.drawable.lay_backgroud));
    }

    private boolean verifyNextButton(String dragedImagename)
    {
        boolean returnData = false;

        for (int i = 0; i<listAnswerButtons.size(); i++)
        {
            stateAnswerButtons stateAnswer = listAnswerButtons.get(i);

            if(!stateAnswer.isState() )// verify if the button not is enabled
            {
                String nameButton =  stateAnswer.getSentence_name();

                if(nameButton.equals("and") ||  nameButton.equals("or")) {
                    String nextName = listAnswerButtons.get(i + 1).getSentence_name();
                    String nextName2 = listAnswerButtons.get(i + 2).getSentence_name();
                    if(nameButton.equals(dragedImagename)|| nextName.equals(dragedImagename) || nextName2.equals(dragedImagename))
                        returnData= true;
                }

                else if(nameButton.equals(dragedImagename))
                    returnData= true;

                break; // para el for porque no precisa seguir buscando mas
            }


        }
        return returnData;
    }

    private Point removeShadow(String nameTag)
    {
        int marginTop = 0 ;
        int marginLeft = 0 ;
        int childcount = LyProgram.getChildCount();

        for (int i=0; i < childcount; i++){
            View child = LyProgram.getChildAt(i);

            if(child!=null && child.getClass()==ImageButton.class)// verify of type of image view
            {
                String nameChild  = ((tagImagens)child.getTag()).getNameimg();
                if(nameChild.equals(nameTag) ){
                    RelativeLayout.LayoutParams paramsChild = (RelativeLayout.LayoutParams) child.getLayoutParams();
                    marginTop = paramsChild.topMargin;
                    marginLeft = paramsChild.leftMargin;
                    LyProgram.removeView(child);
                   break;
                }


            }
        }
        Point returnPoint = new Point(marginLeft,marginTop);
        return returnPoint;
    }

    private void desingNextButtom(Point position) {

        ImageButton btnShadow = new ImageButton(this);

        RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams( ViewGroup.LayoutParams.WRAP_CONTENT,ViewGroup.LayoutParams.WRAP_CONTENT );
        params.leftMargin =position.x;
        params.topMargin = position.y;
        final float scale = getResources().getDisplayMetrics().density;
        int pixels = (int) (SIZE_IMAGEBUTTON * scale + 0.5f);

        params.width =pixels;
        params.height = pixels;

        params.leftMargin = position.x + pixels;
        params.topMargin = position.y ;
        btnShadow.setLayoutParams(params);
        btnShadow.setOnDragListener(new MiDragListener());
        btnShadow.setTag(new tagImagens("shadow"));
        LyProgram.addView(btnShadow);
        btnShadow.setVisibility(View.VISIBLE);

    }
    private void  designShadows(Point position)
    {

        System.out.println("Esta en designShadows ");
        ImageButton btnShadow = new ImageButton(this);

        RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams( ViewGroup.LayoutParams.WRAP_CONTENT,ViewGroup.LayoutParams.WRAP_CONTENT );
        params.leftMargin =position.x;
        params.topMargin = position.y;
        final float scale = getResources().getDisplayMetrics().density;
        int pixels = (int) (SIZE_IMAGEBUTTON * scale + 0.5f);

        params.width =pixels;
        params.height = pixels;

        params.leftMargin = position.x ;
        params.topMargin = position.y -pixels ;
        btnShadow.setLayoutParams(params);
        btnShadow.setOnDragListener(new MiDragListener());
        btnShadow.setTag(new tagImagens("shadow_logic"));
        LyProgram.addView(btnShadow);
        btnShadow.setVisibility(View.VISIBLE);

        RelativeLayout.LayoutParams params_down = new RelativeLayout.LayoutParams( ViewGroup.LayoutParams.WRAP_CONTENT,ViewGroup.LayoutParams.WRAP_CONTENT );
        params_down.leftMargin =position.x;
        params_down.topMargin = position.y;
        params_down.width =pixels;
        params_down.height = pixels;
        params_down.leftMargin = position.x ;
        params_down.topMargin = position.y + pixels ;
        ImageButton btnShadow_down = new ImageButton(this);
        btnShadow_down.setLayoutParams(params_down);
        btnShadow_down.setOnDragListener(new MiDragListener());
        btnShadow_down.setTag(new tagImagens("shadow_logic"));
        LyProgram.addView(btnShadow_down);
        btnShadow_down.setVisibility(View.VISIBLE);



    }

    /**
     * @param item  the view that received the drag event
     * @param event the event from {@link android.view.View.OnDragListener#onDrag(View, DragEvent)}
     * @return the coordinates of the touch on x and y axis relative to the screen
     */
    public static Point getTouchPositionFromDragEvent(View item, DragEvent event) {
        Rect rItem = new Rect();
        item.getGlobalVisibleRect(rItem);
        return new Point(rItem.left + Math.round(event.getX()), rItem.top + Math.round(event.getY()));
    }

    private void createNewButtonImage(String nameImage, int index ){

        Drawable drawable = null;
        if(nameImage.equals("start"))
            drawable = getResources().getDrawable(R.drawable.start);
        else if (nameImage.equals("end"))
            drawable = getResources().getDrawable(R.drawable.end);
        else if (nameImage.equals("up"))
            drawable = getResources().getDrawable(R.drawable.up);
        else if (nameImage.equals("down"))
            drawable = getResources().getDrawable(R.drawable.down);
        else if (nameImage.equals("right"))
            drawable = getResources().getDrawable(R.drawable.right);
        else if (nameImage.equals("left"))
            drawable = getResources().getDrawable(R.drawable.left);
        else if (nameImage.equals("light"))
            drawable = getResources().getDrawable(R.drawable.light);
        else if (nameImage.equals("hand"))
            drawable = getResources().getDrawable(R.drawable.hand);
        else if (nameImage.equals("arrow"))
            drawable = getResources().getDrawable(R.drawable.arrow);
        else if (nameImage.equals("and"))
            drawable = getResources().getDrawable(R.drawable.and);
        else if (nameImage.equals("or"))
            drawable = getResources().getDrawable(R.drawable.or);
        else if (nameImage.equals("if"))
            drawable = getResources().getDrawable(R.drawable.ifimg);



        ImageButton newImageButton = new ImageButton(this);
        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams( ViewGroup.LayoutParams.WRAP_CONTENT,ViewGroup.LayoutParams.WRAP_CONTENT );
        final float scale = getResources().getDisplayMetrics().density;
        int pixels = (int) (SIZE_IMAGEBUTTON * scale + 0.5f);

        params.width =pixels;
        params.height = pixels;
        params.setMargins(3,3,3,3);
        params.gravity = Gravity.CENTER;
        newImageButton.setLayoutParams(params);

        newImageButton.setTag(new tagImagens(nameImage));

        newImageButton.setImageDrawable(drawable);



        Drawable drawableButtom = getResources().getDrawable(R.drawable.custom_button_selector);
        newImageButton.setBackground(drawableButtom);
        newImageButton.setOnTouchListener(new MiTouchListener());
        LyButtons.addView(newImageButton, index);
        newImageButton.setVisibility(View.VISIBLE);


    }

    private void playSongFile(int[] tracks) throws IOException {

       
        if (mediaPlayer!=null)
        mediaPlayer.release();

     


        for (int i = 0; i<tracks.length;i++)
            System.out.println("track "+i+"="+tracks[i]);

        currenttrack = 0;
        mediaPlayer = MediaPlayer.create(this,tracks[currenttrack]);
        mediaPlayer.setOnCompletionListener(onCompletionListener);
        mediaPlayer.start();


    }



    private MediaPlayer.OnCompletionListener onCompletionListener = new MediaPlayer.OnCompletionListener() {
        @Override
        public void onCompletion(MediaPlayer mp) {


          
            mediaPlayer.release();
            if (currenttrack < tracks.length) {
                currenttrack++;

                int idTrack = tracks[currenttrack];

                if (idTrack!=0)                {

                    mediaPlayer = MediaPlayer.create(getApplicationContext(), tracks[currenttrack]);
                    mediaPlayer.setOnCompletionListener(onCompletionListener);
                    mediaPlayer.start();
                }
                else
                {
                    clearTraksList();
                }

            }


        }
    };

    private void killMediaPlayer() {
        if (mediaPlayer != null)
        {
            try {
                mediaPlayer.release();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if(null!=mediaPlayer){
            mediaPlayer.release();
        }
    }

    void findBT()
    {
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if(mBluetoothAdapter == null)
        {
            //myLabel.setText("No bluetooth adapter available");
            System.out.println("No bluetooth adapter available");
        }

        if(!mBluetoothAdapter.isEnabled())
        {
            Intent enableBluetooth = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableBluetooth, 0);
        }

        Set<BluetoothDevice> pairedDevices = mBluetoothAdapter.getBondedDevices();
        if(pairedDevices.size() > 0)
        {
            for(BluetoothDevice device : pairedDevices)
            {
                // Name of  Device:
                // CHANGE THE NAME OF DEVICE 
                if(device.getName().equals("LRS_BT"))
                {
                    mmDevice = device;
                    break;
                }
            }
        }
      
        System.out.println("Bluetooth Device Found");
    }
    void openBT() throws IOException
    {
        UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805f9b34fb"); //Standard SerialPortService ID
        mmSocket = mmDevice.createRfcommSocketToServiceRecord(uuid);
        mmSocket.connect();
        mmOutputStream = mmSocket.getOutputStream();
        mmInputStream = mmSocket.getInputStream();

        beginListenForData();

       
        System.out.println("Bluetooth Opened");

    }
    void beginListenForData()
    {
        final Handler handler = new Handler();
        final byte delimiter = 10; //This is the ASCII code for a newline character

        stopWorker = false;
        readBufferPosition = 0;
        readBuffer = new byte[1024];
        workerThread = new Thread(new Runnable()
        {
            public void run()
            {
                while(!Thread.currentThread().isInterrupted() && !stopWorker)
                {
                    try
                    {
                        int bytesAvailable = mmInputStream.available();
                        if(bytesAvailable > 0)
                        {
                            byte[] packetBytes = new byte[bytesAvailable];
                            mmInputStream.read(packetBytes);
                            for(int i=0;i<bytesAvailable;i++)
                            {
                                byte b = packetBytes[i];
                                if(b == delimiter)
                                {
                                    byte[] encodedBytes = new byte[readBufferPosition];
                                    System.arraycopy(readBuffer, 0, encodedBytes, 0, encodedBytes.length);
                                    final String data = new String(encodedBytes, "US-ASCII");
                                    readBufferPosition = 0;

                                    handler.post(new Runnable()
                                    {
                                        public void run()
                                        {
                                            //myLabel.setText(data);
                                            System.out.println(data);
                                        }
                                    });
                                }
                                else
                                {
                                    readBuffer[readBufferPosition++] = b;
                                }
                            }
                        }
                    } catch (IOException ex)
                    {
                        stopWorker = true;
                    }
                }
            }
        });

        workerThread.start();
    }

    void sendData(String txtToSend) throws IOException
    {

        /* Aceleracion

        J ->direcion 90
        B->Right
        K->left
        A comienza a arrancar
        D stop

        */
        /* s= start
        * */
        String msg;
         if(txtToSend.equals("start"))
         {
             System.out.println("start");

             if(aceleration.equals("stop"))
             {
                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion
                 aceleration = "start";
             }

         }
         else if (txtToSend.equals("up"))
         {
             System.out.println("up");

             if(!direction.equals("up")) {
                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());//aceleracion
                 direction = "up";
             }
         }
         else if (txtToSend.equals("hand"))
         {
             System.out.println("hand");

             if(aceleration.equals("stop")) {
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// stop
                 aceleration ="start";
             }


         }
         else if (txtToSend.equals("right"))
         {
             System.out.println("right");

             if(!direction.equals("right") && aceleration.equals("start")) {
                 msg = "B" + "\n";
                 mmOutputStream.write(msg.getBytes());

                 SendDataRequest sendDataRequest = new SendDataRequest(this);
                 sendDataRequest.TimeoutRotateOperation(new GetDataArduino() {
                     @Override
                     public void done(String resposta) throws IOException {

                     }
                 });

                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 direction = "right";
             }
             else if(!direction.equals("right") && aceleration.equals("stop"))
             {

                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion

                 msg = "B" + "\n";
                 mmOutputStream.write(msg.getBytes());

                 SendDataRequest sendDataRequest = new SendDataRequest(this);
                 sendDataRequest.TimeoutRotateOperation(new GetDataArduino() {
                     @Override
                     public void done(String resposta) throws IOException {


                     }
                 });
                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 direction = "right";
                 aceleration = "start";
             }
         }
         else if (txtToSend.equals("left"))
         {
             System.out.println("left");

             if(!direction.equals("left") && aceleration.equals("start")) {

                 msg = "K" + "\n";
                 mmOutputStream.write(msg.getBytes());
                 SendDataRequest sendDataRequest = new SendDataRequest(this);
                 sendDataRequest.TimeoutRotateOperation(new GetDataArduino() {
                     @Override
                     public void done(String resposta) throws IOException {

                     }
                 });
                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 direction = "left";
             }
             else if(!direction.equals("left") && aceleration.equals("stop")) {

                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion
                 msg = "K" + "\n";
                 mmOutputStream.write(msg.getBytes());
                 SendDataRequest sendDataRequest = new SendDataRequest(this);
                 sendDataRequest.TimeoutRotateOperation(new GetDataArduino() {
                     @Override
                     public void done(String resposta) throws IOException {

                     }
                 });
                 msg = "J" + "\n";
                 mmOutputStream.write(msg.getBytes());// direccion 90
                 direction = "left";
                 aceleration = "start";


             }
         }
         else if (txtToSend.equals("arrow"))
         {
             System.out.println(txtToSend);
             if(aceleration.equals("stop")) {
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion
                 aceleration = "start";
             }
         }
         else if (txtToSend.equals("and"))
         {
             System.out.println(txtToSend);
             if(aceleration.equals("stop")) {
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion
                 aceleration = "start";
             }
         }
         else if (txtToSend.equals("or"))
         {
             System.out.println(txtToSend);
             if(aceleration.equals("stop")) {
                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// aceleracion
                 aceleration = "start";
             }
         }

         else if (txtToSend.equals("end"))
         {
             System.out.println("end");

             if(aceleration.equals("start")) {

                 msg = "D" + "\n";
                 mmOutputStream.write(msg.getBytes());// stop
                 aceleration = "stop";
             }
         }
         else if (txtToSend.equals("light"))
         {
             System.out.println("light");

             if(aceleration.equals("stop")) {

                 msg = "A" + "\n";
                 mmOutputStream.write(msg.getBytes());// stop
                 aceleration = "start";
             }
         }



        msg = txtToSend + "\n";
        mmOutputStream.write(msg.getBytes());

    }
    void closeBT() throws IOException
    {
        stopWorker = true;
        mmOutputStream.close();
        mmInputStream.close();
        mmSocket.close();
        System.out.println("Bluetooth Closed");

    }
}
