package com.iot.puc.aplication;

import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.view.View;
import android.widget.ImageButton;

import java.io.IOException;
import java.util.concurrent.TimeoutException;

import static android.view.View.VISIBLE;

/**
 * Created by Jessica on 11/23/2015.
 */
public class SendDataRequest {

    public SendDataRequest(Context context)
    {
    }
    public void TimeoutOperation(stateAnswerButtons stateAnswer, GetDataArduino getDataArduino )
    {
        new TimeoutOperation(stateAnswer,getDataArduino).execute();
    }
    public void TimeoutRotateOperation( GetDataArduino getDataArduino )
    {
        new TimeoutRotateOperation(getDataArduino).execute();
    }

    public class TimeoutOperation extends AsyncTask<Void,Void, String>
    {

        private static final String TAG ="TAG" ;
        stateAnswerButtons stateAnswer;
        GetDataArduino getDataArduino;
        public TimeoutOperation(stateAnswerButtons stateAnswer,GetDataArduino getDataArduino)
        {
            this.stateAnswer = stateAnswer;
            this.getDataArduino = getDataArduino;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(Void... params) {
            try {

                Log.i(TAG, "Going to sleep");
                Thread.sleep(1500);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            return "voltou...";
        }

        @Override
        protected void onPostExecute(String result) {

            Log.i(TAG, "This is executed after 3 seconds and runs on the main thread");
            super.onPostExecute(result);

            ImageButton imageButton =  stateAnswer.getButton_name();
            imageButton.setEnabled(false);
            stateAnswer.setState(false);

            try {
                getDataArduino.done(result);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }


    }
    public class TimeoutRotateOperation extends AsyncTask<Void,Void, String>
    {

        private static final String TAG ="TAG" ;
        GetDataArduino getDataArduino;
        public TimeoutRotateOperation(GetDataArduino getDataArduino)
        {

            this.getDataArduino = getDataArduino;
        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(Void... params) {
            try {

                Log.i(TAG, "Going to sleep");
                Thread.sleep(800);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            return "voltou...";
        }

        @Override
        protected void onPostExecute(String result) {

            Log.i(TAG, "This is executed after 0.5 seconds and runs on the main thread");
            super.onPostExecute(result);

            try {
                getDataArduino.done(result);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }


    }

}
